<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Visualizar Asignaciones</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong
          >Asigna a un Certificador para las sucursales de tu territorio</strong
        >
        <div class="supSec">
          <strong
            >Trimestre: {{ getTrimestres() }} / Año:
            {{ anio.getFullYear() }}</strong
          >
        </div>
      </div>
    </div>
    <!-- termina Encabezado -->

    <!-- drag and drop -->
    <v-container fluid>
      <div class="contSecc" @dragover.prevent @drop.prevent>
        <div class="gris" @drop="handleFileDrop">
          <!-- 
              <br/>
              <div class="punteado">
                  <div class="file-wrapper ">
                    <img
                      src="@/assets/img/cloud-computing.svg"
                      style="height:40px;width:60px" />
                    <br/>
                          <input type="file" name="fileInput" @change="handleFileInput" multiple=false />
                          <label> Primer paso. Suelta aquí el layout de Asignaciones para subir tu información.</label>
                  </div>
                  <ul>
                    <li v-for="(file) in files" v-bind:key="file">
                      <label>{{file.name}}{{file.size}}</label>
                    </li>
                  </ul>              
              </div>
              <div class="btnCenter"> 
                            <v-btn color="primary" dark @click="readFile">
                            <strong style="fond-size : 16px; color:  #000;"> Seleccionar Archivo</strong>
                            </v-btn>
                  </div>
            -->
          <div style="background: #fafafa">
            <div class="contModal cmodal">
              <div class="amodal tCenter">
                <div
                  class="myDropProtocolos dropzone dz-clickable dz-verfolow rayado"
                  v-cloak
                  @drop.stop.prevent="readFile"
                  @dragover.prevent
                >
                  <div class="dz-default dz-message" data-dz-message>
                    <div class="padding">
                      <img
                        src="@/assets/img/cloud-computing.svg"
                        style="height: 80px; width: 90px"
                        alt
                      />
                    </div>
                    <div>
                      <strong>
                        <b class="name-file">{{ file.name_file }}</b>
                      </strong>
                      <br />
                      <br />
                      <b>
                        Primer paso. Suelta aquí el layout de Asignaciones para
                        subir tu información.
                        <div class="btnCenter file-select file-wrapper padding">
                          <v-btn color="primary" dark>
                            <strong style="fond-size: 16px; color: #000"
                              >Seleccionar Archivo
                              <input
                                type="file"
                                accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
                                @change="readFile"
                            /></strong>
                          </v-btn>
                          <v-btn
                            color="primary"
                            dark
                            class="ml-5"
                            @click="valorTab = true"
                          >
                            <strong style="fond-size: 16px; color: #000"
                              >Cargar Datos
                            </strong>
                          </v-btn>
                        </div>
                      </b>
                      <h6>
                        <label
                          >No cuentas con el layout
                          <a
                            href="http://10.53.33.82/franquicia/Layout_Asignacion.xlsx"
                            class="dz-clickable"
                            >Descargalo aqui</a
                          >
                        </label>
                      </h6>
                    </div>
                  </div>
                  <br />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </v-container>
    <!-- tabla y encabezado tabla -->
    <div class="contSecc">
      <hr
        role="separator"
        aria-orientation="horizontal"
        class="v-divider theme--light"
      />
      <div class="contSecc">
        <div class="titSec" v-if="valorTab">
          <h2>
            Segundo Paso: Visualiza, verifica y corrige, si es necesario, tus
            asignaciones.
          </h2>
        </div>
      </div>
      <div class="divBuscador" v-if="valorTab">
        <div>
          <v-text-field
            v-model="search"
            class="buscador"
            append-icon="mdi-magnify"
            label="Buscar..."
            single-line
            hide-details
            clearable
          >
          </v-text-field>
        </div>
      </div>
      <v-data-table
        v-if="valorTab"
        :headers="encabezadoAsignacion"
        :items="asignaciones"
        :page.sync="page"
        :items-per-page="itemsPerPage"
        @page-count="pageCount = $event"
        append-icon="search"
        ref="tabla"
        :search="search"
        class="tblGeneral tblAsignacionPrevia"
      >
        <template v-slot:item.Eliminar="{ item }">
          <button
            @click="
              (dialogElimina = true),
                (itemSeleccionado = item),
                (asignacionEliminar = item)
            "
          >
            <strong style="fond-size: 16px">Eliminar</strong>
          </button>
        </template>
      </v-data-table>
      <!--fin de tabla  -->
      <!-- Boton añadir asignacion 
           
                    <v-btn color="grey" dark @click="dialogAsignacion=false" class="mr-5">
                            <strong style="fond-size :16px; color: #000;">No, Cancelar</strong>
                    </v-btn>
            -->
      <div>
        <div class="btnCenter" v-if="valorTab">
          <v-btn color="primary" dark @click="dialogAsignacion = true">
            <strong style="fond-size: 16px; color: #000"
              >Añadir Asignacion</strong
            >
          </v-btn>
        </div>
      </div>

      <!-- PAGINADO
        <div class="v-data-footer">
        <div class="text-center pt-2" v-if="valorTab">
                <v-pagination
                    v-model="page"
                    :length="pageCount"
                    class="paginador">
                </v-pagination>
        </div>
        </div>
        -->
    </div>
    <!-- fin container-->
    <div class="contSecc">
      <div class="titSec" v-if="valorTab">
        <h2>Último Paso: ¿Toda tu información es correcta?</h2>
      </div>
    </div>
    <div>
      <div class="btnCenter" v-if="valorTab">
        <v-btn
          color="grey"
          dark
          @click="
            dialogAsignacion = false;
            limpiaFormulario();
          "
          class="mr-5"
        >
          <strong style="fond-size: 16px; color: #000">No, Cancelar</strong>
        </v-btn>
        <v-btn color="primary" dark @click="cargaAsignaciones()">
          <strong style="fond-size: 16px; color: #000"
            >Si, guardar asignaciones</strong
          >
        </v-btn>
      </div>
    </div>

    <!-- Dialog Elimina -->
    <v-dialog v-model="dialogElimina" max-width="800" persistent>
      <v-card class="padding">
        <v-card-title class="headline">
          <div class="titModal">
            <div><strong>¿Deseas eliminar la visita?</strong></div>
          </div>
        </v-card-title>
        <div class="contModal tCenter">
          <div>
            ¿Estás seguro que deseas eliminar la visita a:
            <strong>{{ this.itemSeleccionado.eco }} </strong>
            <strong>{{ this.itemSeleccionado.nombreCeco }} para </strong>
            <strong>{{ this.itemSeleccionado.nombreUsuario }}</strong>
          </div>
          <div></div>
        </div>

        <div class="btnCenter">
          <v-btn color="grey" dark @click="dialogElimina = false" class="mr-10">
            <strong style="fond-size: 16px">No, Conservar visita</strong>
          </v-btn>

          <v-btn
            color="primary"
            dark
            class=""
            @click="
              (dialogConfimacion = true),
                (dialogElimina = false),
                eliminaAsignacionPrevia()
            "
          >
            <strong style="fond-size: 16px; color: #000"
              >Si, eliminar visita</strong
            >
          </v-btn>
        </div>
      </v-card>
    </v-dialog>
    <!-- Dialog Confirmacion Eliminacion -->
    <v-dialog v-model="dialogConfimacion" max-width="600" persistent>
      <v-card class="padding">
        <v-card-title class="headline">
          <div class="titModal">
            <div><strong>Visita eliminada</strong></div>
          </div>
        </v-card-title>
        <div class="contModal tCenter">
          <div>
            La visita a:
            <strong>{{ this.itemSeleccionado.eco }} </strong>
            <strong>{{ this.itemSeleccionado.nombreCeco }} para </strong>
            <strong>{{ this.itemSeleccionado.nombreUsuario }}</strong>
            ,ha sido eliminada.
          </div>
        </div>
        <div class="btnCenter">
          <v-btn color="primary" dark @click="dialogConfimacion = false">
            <strong style="fond-size: 16px; color: #000">¡De acuerdo!</strong>
          </v-btn>
        </div>
      </v-card>
    </v-dialog>
    <!-- Dialog Confirmacion Alta -->
    <v-dialog v-model="dialogConfimacionAlta" max-width="600" persistent>
      <v-card class="padding">
        <v-card-title class="headline">
          <div class="titModal">
            <div><strong>Visita Asignada</strong></div>
          </div>
        </v-card-title>
        <div class="contModal tCenter">
          <div>
            La visita a
            <Strong>
              CECO: {{ cecoSeleccionado.idCeco }} A
              {{ usuarioEncontrado.nombreUsuario }}
            </Strong>
            ,ha sido Asignada.
          </div>
        </div>
        <div class="btnCenter">
          <v-btn color="primary" dark @click="altaAsignacionPrevia()">
            <strong style="fond-size: 16px; color: #000">¡De acuerdo!</strong>
          </v-btn>
        </div>
      </v-card>
    </v-dialog>

    <!-- Dialog Carga Asignacion -->
    <v-dialog v-model="dialogCarga" max-width="600" persistent>
      <v-card class="padding">
        <v-card-title class="headline">
          <div class="titModal">
            <div><strong>¡Carga de asignaciones exitosa!</strong></div>
          </div>
        </v-card-title>
        <div class="contModal tCenter">
          <div>
            La carga de asignaciones ha sido exitosa. Podrás visualizar dichas
            asignaciones en la sección
            <strong>Visualizar Asignaciones.</strong>
          </div>
        </div>
        <div class="btnCenter">
          <v-btn
            color="primary"
            dark
            @click="
              dialogCarga = false;
              irAasignador();
            "
          >
            <strong style="fond-size: 16px; color: #000"
              >Visualizar Asignaciones</strong
            >
          </v-btn>
          <v-btn
            color="primary"
            dark
            @click="
              dialogCarga = false;
              irAasignador();
            "
          >
            <strong style="fond-size: 16px; color: #000">Cancelar</strong>
          </v-btn>
        </div>
      </v-card>
    </v-dialog>

    <!-- Dialog fallo -->
    <v-dialog v-model="dialogFallo" max-width="600" persistent>
      <v-card class="padding">
        <v-card-title class="headline">
          <div class="titModal">
            <div><strong>Algo paso al Cargar el archivo</strong></div>
          </div>
        </v-card-title>
        <div class="contModal tCenter">
          <div>Verifica los campos del Layout</div>
        </div>
        <div class="btnCenter">
          <v-btn color="primary" dark @click="dialogFallo = false">
            <strong style="fond-size: 16px; color: #000">¿Reintentar?</strong>
          </v-btn>
        </div>
      </v-card>
    </v-dialog>
    <!-- Dialog dialogAsignacion -->
    <v-dialog v-model="dialogAsignacion" persistent max-width="600px">
      <v-card>
        <div class="gris">
          <v-card-title class="headline">
            <div class="titModal">
              <div><strong>Alta Asignacion</strong></div>
            </div>
          </v-card-title>

          <div class="contModal tCenter">
            <strong>Ingresa datos para la asignación</strong>
          </div>

          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Usuario a asignar:</strong>
              <br />
              <div class="pRelative">
                <v-autocomplete
                  ref="autoUsuario"
                  no-filter
                  v-model="usuarioEncontrado"
                  :items="metadata.usuarios"
                  clearable
                  append-icon
                  item-value="idUsuario"
                  item-text="nombreUsuario"
                  placeholder="Buscar Usuario"
                  :search-input.sync="textoUsuarioIngresado"
                  :rules="[
                    !!usuarioEncontrado || 'Debes Seleccionar un usuario',
                  ]"
                  :cache-items="false"
                  @keyup="actualizaUsuarios"
                  return-object
                ></v-autocomplete>
              </div>
            </div>
          </div>

          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Negocio:</strong>
              <br />
              <div class="pRelative">
                <v-select
                  ref="autoNegocio"
                  v-model="negocioSelecionado"
                  :items="metadata.negocios"
                  item-value="acronimo"
                  item-text="descripcion"
                  dense
                  hide-no-data
                  clearable
                  append-icon
                  placeholder="Buscar Negocio"
                  :cache-items="false"
                  @click="getNegocios"
                  return-object
                ></v-select>
                <input
                  type="submit"
                  class="buscar"
                  value
                  @click="getNegocios()"
                />
              </div>
            </div>
          </div>

          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Ceco a asignar:</strong>
              <br />
              <div class="pRelative">
                <v-autocomplete
                  ref="autoCeco"
                  v-model="cecoSeleccionado"
                  :items="metadata.cecos"
                  item-value="ceco"
                  item-text="ceco"
                  dense
                  hide-no-data
                  append-icon
                  clearable
                  :disabled="habilitaSuc"
                  placeholder="Buscar Ceco"
                  :cache-items="false"
                  :search-input.sync="textoIngresado"
                  :rules="[
                    () => !!cecoSeleccionado || 'Debes seleccionar un ceco',
                  ]"
                  @keyup="actualizaCecos()"
                  return-object
                ></v-autocomplete>
                <input type="submit" class="buscar" value @click="getCecos()" />
              </div>
            </div>
          </div>
          <!-- Gerente -->
          <div class="divCol spaceCol">
            <div class="col12">
              <strong>Gerente a asignar:</strong>
              <br />
              <div class="pRelative">
                <v-autocomplete
                  ref="autoGerente"
                  no-filter
                  v-model="gerenteEncontrado"
                  :items="metadata.gerentes"
                  clearable
                  dense
                  hide-no-data
                  append-icon
                  item-value="idUsuario"
                  item-text="nombreUsuario"
                  placeholder="Buscar Gerente"
                  :search-input.sync="textoGerente"
                  :rules="[
                    !!gerenteEncontrado || 'Debes Seleccionar un usuario',
                  ]"
                  :cache-items="false"
                  @keyup="actualizaUsuariosGerentes"
                  return-object
                ></v-autocomplete>
              </div>
            </div>
          </div>

          <!-- Territorio -->
          <div class="divCol spaceCol">
            <div class="col12">
              <strong v-if="this.muestraGeo">Territorio:</strong>
              <br />
              <div class="pRelative">
                <v-text-field
                  ref="autoTerri"
                  v-model="territorio"
                  clearable
                  dense
                  placeholder="Ingresa Territorio"
                  v-if="this.muestraGeo"
                ></v-text-field>
              </div>
            </div>
          </div>

          <!-- Zona
                      :search-input.sync="textoGerente"
                                        :rules="[!!gerenteEncontrado || 'Debes Seleccionar un usuario']"
                                        :cache-items="false"
                                        placeholder="Ingresa Zona"
                                        -->
          <div class="divCol spaceCol">
            <div class="col12">
              <strong v-if="this.muestraGeo"> Zona:</strong>
              <br />
              <div class="pRelative">
                <v-text-field
                  class="form-control"
                  ref="autoZona"
                  v-model="zona"
                  clearable
                  dense
                  append-icon
                  placeholder="Ingresa Zona"
                  v-if="this.muestraGeo"
                ></v-text-field>
              </div>
            </div>
          </div>

          <div class="btnCenter">
            <v-btn
              color="grey"
              dark
              @click="
                dialogAsignacion = false;
                limpiaFormulario();
              "
              class="mr-10"
            >
              <strong style="fond-size: 16px; color: #000">Cancelar</strong>
            </v-btn>
            <v-btn color="primary" dark @click="dialogConfimacionAlta = true">
              <strong style="fond-size: 16px; color: #000">Guardar</strong>
            </v-btn>
          </div>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
const axiosAPILocal = store.state.axiosApiLocal;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
import VisorAsignaciones from "../asignaciones/VisorAsignaciones";
import XLSX from "xlsx";
export default {
  name: "modelo_franquicia_asignador_masivo_superior",
  components: {
    //VisorAsignaciones
  },
  data() {
    return {
      quarter: "",
      trimestres: [
        { trimestre: "Enero-Marzo", id: 0 },
        { trimestre: "Enero-Marzo", id: 1 },
        {
          trimestre: "Abril-Junio",
          id: 2,
        },
        {
          trimestre: "Julio-Septiembre",
          id: 3,
        },
        {
          trimestre: "Octubre-Diciembre",
          id: 4,
        },
      ],
      valorTab: false,
      valorBoton: false,
      datosBase64: "",
      d: new Date(),
      tercerPaso: false,
      anio: new Date(),
      asignacionEliminar: "",
      //dialogs
      dialogConfimacionAlta: false,
      dialogElimina: false,
      dialogConfimacion: false,
      dialogAsignacion: false,
      dialogCarga: false,
      dialogFallo: false,
      //valores para servicios
      cecoIngresado: "",
      cecoSeleccionado: "",
      cecosEncontrados: [],
      usuarioEncontrado: "",
      textoIngresado: "",
      itemSeleccionado: "",
      negocioSelecionado: "",
      textoUsuarioIngresado: "",
      habilitaSuc: true,
      gerenteEncontrado: "",
      textoGerente: "",
      muestraGeo: false,
      zona: "",
      territorio: "",
      //valores paginado
      pageCount: 1,
      page: 1,
      itemsPerPage: 10,
      search: "",
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10],
      },
      files: [],
      file: {
        form_data: null,
        name_file: null,
        content_b64: null,
        content_type: null,
      },
      encabezadoAsignacion: [
        {
          text: "Economico",
          value: "eco",
          align: "center",
        },
        {
          text: "Nombre Sucursal",
          value: "nombreCeco",
          align: "center",
        },
        {
          text: "Visita",
          value: "acronimo",
          align: "center",
        },
        {
          text: "No.Empleado",
          value: "idUsuario",
          align: "center",
        },
        {
          text: "Nombre Visitante",
          value: "nombreUsuario",
          align: "center",
        },
        {
          text: "Eliminar",
          value: "Eliminar",
          align: "center",
        },
      ],
      asignaciones: [],
      metadata: {
        cecos: [],
        usuarios: [],
        negocios: [],
        gerentes: [],
      },

      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Asignaciones",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_asignaciones_home_asignacion",
          },
        },
        {
          text: "Asignacion Masiva",
          disabled: true,
        },
      ],
    };
  }, //fin data
  methods: {
    handleFileDrop(e) {
      this.files = [];
      let droppedFiles = e.dataTransfer.files;
      if (!droppedFiles) return;
      [...droppedFiles].forEach((f) => {
        this.files.push(f);
      });
    },
    handleFileInput(e) {
      this.files = [];
      let files = e.target.files;
      if (!files) return;
      [...files].forEach((f) => {
        this.files.push(f);
      });
    },

    readFile(e) {
      let file;
      if (e.type === "drop") {
        file = e.dataTransfer.files[0];
      } else {
        file = e.target.files[0];
      }
      if (!file) return;
      const size = file.size;
      if (size > 1024 * 1024) {
        this.dialogSize = true;
        return;
      }
      this.file.form_data = file;
      this.file.name_file = file.name;
      this.file.content_type = file.type;
      const reader = new FileReader();
      reader.readAsDataURL(file);
      reader.onload = (e) => {
        let result = e.target.result;
        this.file.content_b64 = result.split(",")[1];
        this.validaExcel();
        //console.log(JSON.stringify(this.file))
        //ejecutar servicio
        //mandar this.file.content_b64 al servicio
      };
    },
    //Inicia cecos
    getCecos() {
      axios
        .post("negoVers/secure/post/cecos", {
          prefijo: this.prefijo,
          idCeco: this.ceco,
          nombreCeco: this.nombre,
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              this.metadata.cecos = [];

              for (var i = 0; i < response.data.data.length; i++) {
                this.metadata.cecos.push({
                  nombreCeco: response.data.data[i].nombreCeco,
                  ceco:
                    response.data.data[i].nombreCeco +
                    " - " +
                    response.data.data[i].idCeco,
                  idCeco: response.data.data[i].idCeco,
                });
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaCecos() {
      if (
        this.textoIngresado != null &&
        this.textoIngresado.length > 3 &&
        this.negocioSelecionado.idNegocio == 1
      ) {
        this.prefijo = 92;
        this.ceco = null;
        this.nombre = this.textoIngresado;
        this.muestraGeo = true;
        this.getCecos();
      } else if (
        this.textoIngresado != null &&
        this.textoIngresado.length > 3 &&
        this.negocioSelecionado.idNegocio == 5
      ) {
        this.prefijo = 23;
        this.ceco = null;
        this.nombre = this.textoIngresado;
        this.muestraGeo = true;
        this.getCecos();
      } else if (
        this.textoIngresado != null &&
        this.textoIngresado.length > 3 &&
        (this.negocioSelecionado.idNegocio == 8 ||
          this.negocioSelecionado.idNegocio == 7)
      ) {
        this.prefijo = 55;
        this.ceco = null;
        this.nombre = this.textoIngresado;
        this.muestraGeo = true;
        this.getCecos();
      } else {
        this.metadata.cecos = [];
      }
    },
    //finaliza cecos
    /* INICIA USUARIOS */
    getUsuarios() {
      axios
        .post("/negoVers/secure/post/usuarios", {
          id_usuario: this.idUsuario,
          nombreUsuario: this.nombreUsuario,
          idPuesto: this.idPuesto,
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.usuarios = response.data.data;
                //console.log(JSON.stringify(this.metadata.usuarios))
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },

    getUsuariosAPILocal() {
      this.isLoading = true;
      var self = this;
      console.log("1");
      let options = {
        usuario: self.textoUsuarioIngresado,
      };
      axiosAPILocal
        .post("/usuarios-negocio/v1/busquedas", options)
        .then((response) => {
          let data = response.data;
          if (data) {
            this.metadata.usuarios = [];
            let usuarios = [];

            data.resultado.usuarios.forEach((element) => {
              let usuario = {
                idUsuario: element.numeroEmpleado,
                nombreUsuario: element.numeroEmpleado + " - " + element.nombre,
                idPuesto: 0,
              };
              usuarios.push(usuario);
            });

            this.metadata.usuarios = usuarios;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.isLoading = false;
        });
    },

    actualizaUsuarios() {
      if (
        this.textoUsuarioIngresado != null &&
        this.textoUsuarioIngresado.length > 3
      ) {
        this.getUsuariosAPILocal();
      } else {
        this.metadata.usuarios = [];
      }
    },
    /* FIN USUARIOS */
    /* INICIA GERENTES */
    getUsuariosGerentes() {
      axios
        .post("/negoVers/secure/post/usuarios", {
          id_usuario: this.idUsuario,
          nombreUsuario: this.nombreUsuario,
          idPuesto: this.idPuesto,
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.gerentes = response.data.data;
                //console.log("entro")
                // console.log(JSON.stringify(this.metadata.gerentes))
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },

    getUsuariosGerentesAPILocal() {
      this.isLoading = true;
      var self = this;
      console.log("2");
      let options = {
        usuario: self.textoGerente,
      };
      axiosAPILocal
        .post("/usuarios-negocio/v1/busquedas", options)
        .then((response) => {
          let data = response.data;
          if (data) {
            this.metadata.gerentes = [];
            let usuarios = [];

            data.resultado.usuarios.forEach((element) => {
              let usuario = {
                idUsuario: element.numeroEmpleado,
                nombreUsuario: element.numeroEmpleado + " - " + element.nombre,
                idPuesto: 0,
              };
              usuarios.push(usuario);
            });

            this.metadata.gerentes = usuarios;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.isLoading = false;
        });
    },
    actualizaUsuariosGerentes() {
      if (this.textoGerente != null && this.textoGerente.length > 3) {
        this.getUsuariosGerentesAPILocal();
      } else {
        this.metadata.gerentes = [];
      }
    },
    /* FIN GERENTES */

    //OBTIENEN negocios
    getNegocios() {
      axios
        .post("/negoVers/secure/post/negocio", {
          idNegocio: null,
        })
        .then((response) => {
          //console.log(JSON.stringify(response.data.data))
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.negocios = response.data.data;
                this.metadata.cecos = [];
                this.habilitaSuc = false;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    }, //fin negocios
    //ALTA ASIGNACION
    altaAsignacion() {
      this.objAdd = {
        idUsuario: this.usuarioEncontrado.idUsuario,
        idCeco: this.cecoSeleccionado.idCeco,
        nombreCeco: this.cecoSeleccionado.nombreCeco,
        idPerfil: 1,
        idNegocio: this.negocioSelecionado.idNegocio,
        idGerente: this.gerenteEncontrado.idUsuario,
        territorio: this.territorio,
        zona: this.zona,
      };
      //console.log( JSON.stringify(this.objAdd.idCeco.toString().substring(2,6)));
      axios
        .post("asignacion-sup/secure/post/alta/asignacion", this.objAdd)
        .then((response) => {
          //console.log("no Jalo la asignacion" + JSON.stringify(this.objAdd));
          if (response) {
            if (response.status == 200) {
              if (response.data.data == 1) {
                this.dialogConfimacionAlta = true;
                this.dialogAsignacion = false;
                this.habilitaSuc = true;
              } else {
                //alert("no Jalo la asignacion" + JSON.stringify(this.objAdd));
                this.dialogFallo = true;
                this.usuarioEncontrado = "";
                this.cecoSeleccionado = "";
                this.negocioSelecionado = "";
                this.$refs.autoUsuario.resetValidation();
                this.$refs.autoCeco.resetValidation();
                this.habilitaSuc = true;
              }
            }
            this.usuarioEncontrado = "";
            this.cecoSeleccionado = "";
            this.negocioSelecionado = "";
            this.$refs.autoUsuario.resetValidation();
            this.$refs.autoCeco.resetValidation();
            this.habilitaSuc = true;
            this.muestraGeo = false;
            this.zona = "";
            this.territorio = "";
            this.metadata.gerentes = [];
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    altaAsignacionPrevia() {
      this.asignaciones.push({
        eco: this.cecoSeleccionado.idCeco.toString().substring(2, 6),
        nombreCeco: this.cecoSeleccionado.ceco,
        acronimo: this.negocioSelecionado.acronimo,
        idUsuario: this.usuarioEncontrado.idUsuario,
        nombreUsuario: this.usuarioEncontrado.nombreUsuario,
        numeroGerente: this.gerenteEncontrado.idUsuario,
        territorio: this.territorio,
        zona: this.zona,
      });
      /*this.altaAsignaGeo();
      this.dialogConfimacionAlta = false;
      this.dialogConfimacion = false;
      this.dialogAsignacion = false;
      this.cecoSeleccionado = "";
      this.usuarioEncontrado = "";
      this.negocioSelecionado = "";
      this.$refs.autoUsuario.resetValidation();
      this.$refs.autoCeco.resetValidation();
      this.habilitaSuc = true;
      this.muestraGeo = false;
      this.zona = "";
      this.territorio = "";
      this.metadata.gerentes = [];
      this.$refs.autoGerente.resetValidation();*/
    },
    eliminaAsignacionPrevia() {
      // alert(JSON.stringify(this.asignacionEliminar))
      for (var i = 0; i < this.asignaciones.length; i++) {
        //console.log(JSON.stringify(this.asignaciones[i]))
        if (
          this.asignacionEliminar.eco === this.asignaciones[i].eco &&
          this.asignacionEliminar.idUsuario ===
            this.asignaciones[i].idUsuario &&
          this.asignacionEliminar.acronimo == this.asignaciones[i].acronimo
        ) {
          this.asignaciones.splice(i, 1); // el uno es para indicarle que borre un elemento
          return;
        }
      }
    }, //elimina asignacion
    getTrimestres() {
      this.quarter = Math.ceil(this.d.getMonth() / 3);
      //this.quarter = this.quarter;
        //console.log(this.trimestres[this.quarter].id);
      if (this.quarter === this.trimestres[this.quarter].id) {
        return this.trimestres[this.quarter].trimestre;
      }
    },
    cargaAsignaciones() {
      JSON.stringify(this.asignaciones);
      console.log(JSON.stringify(this.asignaciones));
      {
        axios
          .post(
            "/asignacion-sup/secure/post/ejecuta/asignaciones",
            this.asignaciones
          )
          .then((response) => {
            if (response) {
              // alert(JSON.stringify(response.data))
              //alert(JSON.stringify(response.data.data))
              //console.log("paso 1"+JSON.stringify(this.asignaciones))

              if (response.status == 200 && response.data.data == 1) {
                this.dialogCarga = true;
                this.dialogConfimacionAlta = false;
                this.dialogAsignacion = false;
                //this.asignaciones = [];
                this.valorTab = false;
              } else {
                //alert("no Jalo la asignacion" + JSON.stringify(this.datos));
                this.dialogFallo = true;
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function() {});
      }
    }, //fin carga asignaciones
    validaExcel() {
      this.archivo = {
        archivoAsignaciones: this.file.content_b64,
      };
      axios
        .post("asignacion-sup/secure/post/carga/asignacionexcel", this.archivo)
        .then((response) => {
          if (response) {
            if (response.status == 200) {
              if (response.data.data != undefined) {
                this.asignaciones = response.data.data;
                // console.log("Asignaciones array"+JSON.stringify(this.asignaciones))
              } else {
                this.dialogFallo = true;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    }, //fin valida exce
    //ir a una ruta
    irAasignador() {
      router.push({
        name: "modelo_franquicia_visor_asignaciones",
      });
    },
    limpiaFormulario() {
      this.usuarioEncontrado = "";
      this.cecoSeleccionado = "";
      this.listaTipoNego = "";
      this.metadata.cecos = [];
      this.metadata.negocios = [];
      this.metadata.usuarios = [];
      this.$refs.autoUsuario.resetValidation();
      this.$refs.autoCeco.resetValidation();
      this.habilitaSuc = true;
      this.muestraGeo = false;
      this.zona = "";
      this.territorio = "";
      this.metadata.gerentes = [];
      this.$refs.autoGerente.resetValidation();
    },
  },
};
</script>

<style>
.punteado {
  border-style: dotted;
  border-width: 2px;
  border-color: 660033;
  background-color: cc3366;
  font-size: 20pt;
  padding: 10px;
}

.rayado {
  border-style: dashed;
  border-width: 2px;
  border-color: 660033;
  padding: 10px;
  font-size: 20pt;
}

.altura {
  height: 60px;
}

.anchura {
  width: 200px;
}

.file-wrapper {
  text-align: center;
  width: 100%;
  height: 3em;
  vertical-align: middle;
  position: relative;
  overflow: hidden;
}

.file-wrapper input {
  position: absolute;
  top: 0;
  right: 0;
  cursor: pointer;
  opacity: 0;
  filter: alpha(opacity=0);
  width: 100%;
  height: 100%;
}
.padding {
  padding: 20px;
}
</style>
